//+------------------------------------------------------------------+
//|                                                  New Big Dog.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs
extern int MaxRisk=2;
extern int TakeProfit=100;
extern int StopLoss=100;
extern int HourA=7;
extern int HourB=9;
extern int Hour=19;

int
  tic,
  Gran=0,
  Kvadrat=0;
  
double
  Lot,
  MAX,
  MIN;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
if(Hour()==HourA && Minute()==0 && Seconds()==0)
   {
   ObjectsDeleteAll(0,-1);
   ObjectCreate("vline_1",OBJ_VLINE,0,TimeCurrent(),0);
   }
      
if(Hour()==HourB && Minute()==0 && Seconds()==0)
   {
   ObjectCreate("vline_2",OBJ_VLINE,0,TimeCurrent(),0);
   Gran=1;
   }
   
if(Gran==1)
   {
   MIN=iLow(NULL,0,iLowest(NULL,0,MODE_LOW,(HourB-HourA)*5-1,0));
   MAX=iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,(HourB-HourA)*5-1,0));
   ObjectCreate("hline_1",OBJ_HLINE,0,0,MIN);
   ObjectCreate("hline_2",OBJ_HLINE,0,0,MAX);
   Gran=0;
   Kvadrat=1;
   }

if(Kvadrat==1)
   {
   Lot=GetLot(MaxRisk);
   NewOrder(OP_SELLSTOP);
   NewOrder(OP_BUYSTOP);
   Kvadrat=0;
   }
   
if(Hour()==Hour && Minute()==0 && Seconds()==0)
   yDeleteOrder();   
//----
   return(0);
  }
//----------------------------------------------------------------------
//----------------------   -----------------------------
//----------------------------------------------------------------------  


//+---------  ---------------------------------------+
double GetLot(int Risk)
{
 double Free=AccountFreeMargin();
 double One_Lot=MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);
 double Max_Lot=MarketInfo(Symbol(),MODE_MAXLOT);
 double Step=MarketInfo(Symbol(),MODE_LOTSTEP);
 double Lot=MathFloor(Free*Risk/100/One_Lot/Step)*Step;
 if(Lot<Min_Lot)Lot=Min_Lot;
 if(Lot>Max_Lot)Lot=Max_Lot;
 if(Lot*One_Lot>Free)return(0.0);
 return(Lot);
}

//+----------  -----------------------------------+
int NewOrder(int Cmd)
{
 double TP=0;// 
 double SL=0;// 
 double PR=0;// 
 while(!IsTradeAllowed())Sleep(100);
 if(TakeProfit<MarketInfo(Symbol(),MODE_STOPLEVEL))  
    TakeProfit=MarketInfo(Symbol(),MODE_STOPLEVEL);
 if(StopLoss<MarketInfo(Symbol(),MODE_STOPLEVEL))  
    StopLoss=MarketInfo(Symbol(),MODE_STOPLEVEL);
 if(Cmd==OP_BUYSTOP)
   {
    PR=MAX;
    if(TakeProfit>0)TP=NormalizeDouble(MAX+TakeProfit*Point,Digits);
    if(StopLoss>0)  SL=NormalizeDouble(MAX-StopLoss*Point,Digits);
   }
 if(Cmd==OP_SELL)
   {
    PR=MIN;
    if(TakeProfit>0)TP=NormalizeDouble(MIN-TakeProfit*Point,Digits);
    if(StopLoss>0)  SL=NormalizeDouble(MIN+StopLoss*Point,Digits);
   }
 tic=OrderSend(Symbol(),Cmd,Lot,PR,3,SL,TP,"",0,0,CLR_NONE);
 if(tic<0)Print("  :",GetLastError()); Print("Cmd-",Cmd,"Lot=",Lot,"PR=",PR,"SL=",SL,"TP=",TP);
return(tic);
}

//+-----------  ----------------------------------+
int yDeleteOrder()
{
   for(int i=1; i<=OrdersTotal(); i++)
      {
         if(OrderSelect(i-1,SELECT_BY_POS)==true)
            {
               if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
                     OrderDelete(OrderTicket());
            }
         else
            Print("OrderSelect()   - ",GetLastError());
      }
   return(0);
} 
 
 
 